// Doors

var doorOpenSound : AudioClip;
var doorCloseSound : AudioClip;
var doorCloseSoundPause = 50.0;
var doorOpenCloseSpeed = 1;

private var ColorChangerScript : ColorChanger; // handle to our ColorChanger script(needed to test mouse touch events)
private var doorJoint : ConfigurableJoint; // handle to our component
private var doorSpeed = 0;
private var doorCloseSoundPauseInit = 0.0;
private var doorOpenCloseSoundFlag = false; // trigger for close sound to play(needed because the sound has to delay)
private var doorOpenClose = true; // false=closed, true=open
private var onMouseDownFlag = false;
private var closedDoorPosition = 0.0;

function Start()
{
	doorJoint = GetComponent(ConfigurableJoint);
	if(!doorJoint) { Debug.Log("No handle to door joint"); }
	ColorChangerScript = GetComponent(ColorChanger);
	if(!ColorChangerScript) { Debug.Log("No Handle to ColorChanger script"); }
	
	doorJoint.targetAngularVelocity = Vector3.zero; // initialize to no movement
	doorSpeed = doorOpenCloseSpeed;
	closedDoorPosition = transform.eulerAngles.y; // initialize all doors closed rotation
}

function OnMouseDown()
{
	doorOpenClose = (doorOpenClose == false);
	onMouseDownFlag = true;
}

function FixedUpdate()
{
	if(onMouseDownFlag == true)
	{
		onMouseDownFlag = false; //prevent double triggers
		
		if(doorOpenClose == false) 
		{ 
			audio.PlayClipAtPoint(doorOpenSound,transform.position);
			doorJoint.targetAngularVelocity = Vector3(doorSpeed,0,0);
		}
		else 
		{ 
			doorOpenCloseSoundFlag = true;
			doorJoint.targetAngularVelocity = Vector3(-doorSpeed,0,0);
		}
	}
	if(doorOpenCloseSoundFlag)
	{
		doorCloseSoundPauseInit += Mathf.Sign(Mathf.Abs(transform.eulerAngles.y));
		if(doorCloseSoundPauseInit > 90.0-3.0) // delay for sound
		{
			audio.PlayClipAtPoint(doorCloseSound,transform.position);
			doorCloseSoundPauseInit = 0.0;
			doorOpenCloseSoundFlag = false;
		}
	}
}